import nest
import pylab
import random
import os
import stroop_fun4

conditions=0
#1: swt,2:random,0:both

neuron_num = 1000
random.seed(2)

beta=0.7
ca_start_rate = 0.02

conn_rate = 0.058
weight = 68.46

ca_start = int(neuron_num*ca_start_rate)
conn_num = int(conn_rate*neuron_num)

sensor_params = {'withgid': True, 'withtime': True}

if conditions!=2:
    ca_matrix1 = stroop_fun4.small_world(1, neuron_num, neuron_num, conn_num, beta)
    ca_pre = nest.Create('iaf_psc_alpha', neuron_num)
    spike_pre = nest.Create('spike_detector', params=sensor_params)
    nest.Connect(ca_pre, spike_pre)
    for i in range(neuron_num):
       for j in range(neuron_num):
           if ca_matrix1[i][j]==1:
               nest.Connect([ca_pre[i]],[ca_pre[j]],syn_spec={'weight': weight})
    for i in range(ca_start):
        nest.SetStatus([ca_pre[i]], {'I_e':376.0})



if conditions!=1:
    ca_matrix2=stroop_fun4.small_world(2,neuron_num,neuron_num,conn_num,beta)
    ca_pos = nest.Create('iaf_psc_alpha', neuron_num)
    spike_pos = nest.Create('spike_detector', params=sensor_params)
    nest.Connect(ca_pos, spike_pos)
    for i in range(neuron_num):
        for j in range(neuron_num):
            if ca_matrix2[i][j]==1:
                nest.Connect([ca_pos[i]],[ca_pos[j]],syn_spec={'weight': weight})
    for i in range(ca_start):
        nest.SetStatus([ca_pos[i]], {'I_e':376.0})

nest.Simulate(1000)

pylab.figure(1,figsize=(20,20))
if conditions!=2:
    pylab.subplot(2,2,1)
    pylab.title('Ring + Small World')
    stroop_fun4.plot_neuron(spike_pre,'r.')
    pylab.subplot(2,2,3)
    pylab.title('SWT Binned Activation')
    stroop_fun4.plot_spikes(spike_pre,1000,'r')
if conditions!=1:
    pylab.subplot(2,2,2)
    pylab.title('Ring + Random')
    stroop_fun4.plot_neuron(spike_pos,'b.')
    pylab.subplot(2,2,4)
    pylab.title('Random Binned Activation')
    stroop_fun4.plot_spikes(spike_pos,1000,'b')

pylab.show()

duration = 1  # second
freq = 440  # Hz
os.system('play --no-show-progress --null --channels 1 synth %s sine %f' % (duration, freq))

filename='/home/tiger/Downloads/smt/beta='+str(beta)+'.png'
pylab.savefig(filename)
