import nest
import pylab
import random

def small_world(mode,node1,node2,edges,beta):
    conn = [[0 for i in range(node2)] for j in range(node1)]
    margin=float(node2)/node1
    for i in range(node1):
        for j in range(edges):
            if (int(i*margin)+j+1)<node2:
                conn[i][int(i*margin)+j+1]=1
            else:
                conn[i][int(i*margin)+j+1-node2]=1
            if (int(i*margin)-j)>0:
                conn[i][int(i*margin)-j-1]=1
            else:
                conn[i][node2+int(i*margin)-j-1]=1
    connectivity=[1]*node2
    conn_transpose=[[conn[j][i] for j in range(len(conn))] for i in range(len(conn[0]))]
    for i in range(node2):
        connectivity[i]=connectivity[i]+sum(conn_transpose[i])
    for i in range(node1):
        for j in range(node2):
            if conn[i][j]==1 and random.random()<beta:
                new_j = 0
                un_conn = []
                for k in range(node2):
                    if conn[i][k] == 0:
                        un_conn.append(k)
                if mode==1: #small world
                    connectivity_temp=[]
                    for k in un_conn:
                        connectivity_temp.append(connectivity[k])
                    sum_all=sum(connectivity_temp)
                    mark = random.random()
                    sum_count=0
                    while mark>sum_count and new_j+1<len(connectivity_temp):
                        sum_count=sum_count+connectivity_temp[new_j]/sum_all
                        new_j = new_j+1
                    new_j = un_conn[new_j]
                if mode==2: #random
                    new_j=un_conn[random.randint(0,len(un_conn)-1)]

                conn[i][j] = 0
                conn[i][new_j]=1
                connectivity[j]=connectivity[j]-1
                connectivity[new_j]=connectivity[new_j]+1
    return conn


def plot_spikes(sensor_data, simulation_time, plot_color):
    spike_data=nest.GetStatus(sensor_data, keys='events')[0]
    spike_train=spike_data['senders']
    timing=spike_data['times']
    spike_timing=range(0,simulation_time+10,10)
    spike_count=[[] for i in range(len(spike_timing))]
    for i in range(len(timing)):
        found=0
        j=0
        while j<len(spike_timing) and found==0:
            if spike_timing[j]<timing[i]<=spike_timing[j+1]:
                found=1
                spike_count[j+1].append(spike_train[i])
            j=j+1
    for i in range(len(spike_count)):
        spike_count[i]=len(set(spike_count[i]))
    pylab.plot(spike_timing,spike_count,plot_color)
    print(spike_count)

def plot_neuron(sensor_data, plot_color):
    spike_data=nest.GetStatus(sensor_data,keys='events')[0]
    spike_train=spike_data['senders']
    time=spike_data['times']
    pylab.plot(time,spike_train,plot_color)