import nest
import pylab
import stroop_fun
import random

random.seed(1)

condition=[2,0,1] #[inhibition, ink, word]  1 ink/red, 2 word/blue, other nil

firing_rate=0.75
simu_time=1000

ca_number_ink=1000
ca_number_word=2000
ca_start_rate=0.015
ca_conn_link=0.012

ca_belta_ink=0.1
ca_weight_ink=78.0

ca_belta_word=0.1
ca_weight_word=78.0

ca_conn_out=4
ca_belta_out=0.2
ca_weight_out=10

conn_control_ink=4
belta_control_ink=0.2
weight_control_ink=50.0

conn_control_word=2
belta_control_word=0.2
weight_control_word=40.0

ca_conn_inhi=25
ca_belta_inhi=0.2
ca_weight_inhi=78.0

conn_inhi_ink=5
belta_inhi_ink=0.3
weight_inhi_ink=-25.0

conn_inhi_word=9
belta_inhi_word=0.3
weight_inhi_word=-28.0

conn_cross_ink=3
belta_cross_ink=0.3
weight_cross_ink=-20.0

conn_cross_word=5
belta_cross_word=0.3
weight_cross_word=-25.0

conn_mutual=4
belta_mutual=0.3
weight_mutual=-10.0

neuron_start_ink=int(ca_number_ink*ca_start_rate)
neuron_start_word=int(ca_number_word*ca_start_rate)
ca_conn_ink=int(ca_number_ink*ca_conn_link)
ca_conn_word=int(ca_number_word*ca_conn_link)

neuron_start_inhi=int(ca_number_ink*ca_start_rate*2)
ca_conn_inhi=int(ca_number_ink*ca_conn_link*2)

inhi_ink=nest.Create('iaf_psc_alpha',ca_number_ink)
inhi_word=nest.Create('iaf_psc_alpha',ca_number_ink)
ink_red=nest.Create('iaf_psc_alpha',ca_number_ink)
ink_blue=nest.Create('iaf_psc_alpha',ca_number_ink)
word_red=nest.Create('iaf_psc_alpha',ca_number_word)
word_blue=nest.Create('iaf_psc_alpha',ca_number_word)
out_red=nest.Create('iaf_psc_alpha',ca_number_ink)
out_blue=nest.Create('iaf_psc_alpha',ca_number_ink)

ca_syn_ink={'weight':ca_weight_ink,'delay':0.5}
ca_matrix_ink=stroop_fun.small_world(ca_number_ink,ca_conn_ink,ca_belta_ink)

for i in range(ca_number_ink):
    for j in range(ca_number_ink):
        if ca_matrix_ink[i][j]==1:
            nest.Connect([ink_red[i]],[ink_red[j]],syn_spec=ca_syn_ink)
            nest.Connect([ink_blue[i]],[ink_blue[j]],syn_spec=ca_syn_ink)

ca_syn_word={'weight':ca_weight_word,'delay':0.5}
ca_matrix_word=stroop_fun.small_world(ca_number_word,ca_conn_word,ca_belta_word)

for i in range(ca_number_word):
    for j in range(ca_number_word):
        if ca_matrix_word[i][j]==1:
            nest.Connect([word_red[i]],[word_red[j]],syn_spec=ca_syn_word)
            nest.Connect([word_blue[i]],[word_blue[j]],syn_spec=ca_syn_word)

ca_syn_inhi={'weight':ca_weight_inhi,'delay':0.5}

ca_matrix_inhi=stroop_fun.small_world(ca_number_ink,ca_conn_inhi,ca_belta_inhi)

for i in range(ca_number_ink):
    for j in range(ca_number_ink):
        if ca_matrix_inhi[i][j]==1:
            nest.Connect([inhi_ink[i]],[inhi_ink[j]],syn_spec=ca_syn_inhi)
            nest.Connect([inhi_word[i]],[inhi_word[j]],syn_spec=ca_syn_inhi)

syn_inhi_ink={'weight':weight_inhi_ink,'delay':0.5}
matrix_inhi_ink=stroop_fun.small_world_traj(ca_number_ink,ca_number_ink,conn_inhi_ink,belta_inhi_ink)

for i in range(ca_number_ink):
    for j in range(ca_number_ink):
        if matrix_inhi_ink[i][j]==1:
            nest.Connect([inhi_ink[i]],[ink_red[j]],syn_spec=syn_inhi_ink)
            nest.Connect([inhi_ink[i]],[ink_blue[j]],syn_spec=syn_inhi_ink)

syn_inhi_word={'weight':weight_inhi_word,'delay':0.5}
matrix_inhi_word=stroop_fun.small_world_traj(ca_number_ink,ca_number_word,conn_inhi_word,belta_inhi_word)

for i in range(ca_number_ink):
    for j in range(ca_number_word):
        if matrix_inhi_word[i][j]==1:
            nest.Connect([inhi_word[i]],[word_red[j]],syn_spec=syn_inhi_word)
            nest.Connect([inhi_word[i]],[word_blue[j]],syn_spec=syn_inhi_word)


ca_syn_out={'weight':ca_weight_out,'delay':0.5}
ca_matrix_out=stroop_fun.small_world(ca_number_ink,ca_weight_out,ca_belta_out)

for i in range(ca_number_ink):
    for j in range(ca_number_ink):
        if ca_matrix_out[i][j]==1:
            nest.Connect([out_red[i]],[out_red[j]],syn_spec=ca_syn_out)
            nest.Connect([out_blue[i]],[out_blue[j]],syn_spec=ca_syn_out)


syn_control_ink={'weight':weight_control_ink,'delay':0.5}
matrix_control_ink=stroop_fun.small_world(ca_number_ink,conn_control_ink,belta_control_ink)

for i in range(ca_number_ink):
    for j in range(ca_number_ink):
        if matrix_control_ink[i][j]==1:
            nest.Connect([ink_red[i]],[out_red[j]],syn_spec=syn_control_ink)
            nest.Connect([ink_blue[i]],[out_blue[j]],syn_spec=syn_control_ink)


syn_cross_ink={'weight':weight_cross_ink,'delay':0.5}
matrix_cross_ink=stroop_fun.small_world(ca_number_ink,conn_cross_ink,belta_cross_ink)

for i in range(ca_number_ink):
    for j in range(ca_number_ink):
        if matrix_cross_ink[i][j]==1:
            nest.Connect([ink_red[i]],[out_blue[j]],syn_spec=syn_cross_ink)
            nest.Connect([ink_blue[i]],[out_red[j]],syn_spec=syn_cross_ink)


syn_control_word={'weight':weight_control_word,'delay':0.5}
matrix_control_word=stroop_fun.small_world_traj(ca_number_word,ca_number_ink,conn_control_word,belta_control_word)

for i in range(ca_number_word):
    for j in range(ca_number_ink):
        if matrix_control_word[i][j]==1:
            nest.Connect([word_red[i]],[out_red[j]],syn_spec=syn_control_word)
            nest.Connect([word_blue[i]],[out_blue[j]],syn_spec=syn_control_word)


syn_cross_word={'weight':weight_cross_word,'delay':0.5}
matrix_cross_word=stroop_fun.small_world_traj(ca_number_word,ca_number_ink,conn_cross_word,belta_cross_word)

for i in range(ca_number_word):
    for j in range(ca_number_ink):
        if matrix_cross_word[i][j]==1:
            nest.Connect([word_red[i]],[out_blue[j]],syn_spec=syn_cross_word)
            nest.Connect([word_blue[i]],[out_red[j]],syn_spec=syn_cross_word)


syn_mutual={'weight':weight_mutual,'delay':0.5}
matrix_mutual=stroop_fun.small_world_traj(ca_number_ink,ca_number_ink,conn_mutual,belta_mutual)

for i in range(ca_number_ink):
    for j in range(ca_number_ink):
        if matrix_mutual[i][j]==1:
            nest.Connect([out_red[i]],[out_blue[j]],syn_spec=syn_mutual)

matrix_mutual=stroop_fun.small_world_traj(ca_number_ink,ca_number_ink,conn_mutual,belta_mutual)

for i in range(ca_number_ink):
    for j in range(ca_number_ink):
        if matrix_mutual[i][j]==1:
            nest.Connect([out_blue[i]],[out_red[j]],syn_spec=syn_mutual)


sensor_params = {'withgid':True,'withtime':True}
spike_inhi_ink=nest.Create('spike_detector',params=sensor_params)
spike_inhi_word=nest.Create('spike_detector',params=sensor_params)
spike_ink_red=nest.Create('spike_detector',params=sensor_params)
spike_ink_blue=nest.Create('spike_detector',params=sensor_params)
spike_word_red=nest.Create('spike_detector',params=sensor_params)
spike_word_blue=nest.Create('spike_detector',params=sensor_params)
spike_out_red=nest.Create('spike_detector',params=sensor_params)
spike_out_blue=nest.Create('spike_detector',params=sensor_params)

nest.Connect(inhi_ink,spike_inhi_ink)
nest.Connect(inhi_word,spike_inhi_word)
nest.Connect(ink_red,spike_ink_red)
nest.Connect(ink_blue,spike_ink_blue)
nest.Connect(word_red,spike_word_red)
nest.Connect(word_blue,spike_word_blue)
nest.Connect(out_red,spike_out_red)
nest.Connect(out_blue,spike_out_blue)

if condition[0]==1:
    for i in range(0, neuron_start_inhi-1):
        nest.SetStatus([inhi_ink[i]],{'I_e':376.0})

if condition[0]==2:
    for i in range(0, neuron_start_inhi-1):
        nest.SetStatus([inhi_word[i]], {'I_e': 376.0})

if condition[1]==1:
    for i in range(0,neuron_start_ink-1):
        nest.SetStatus([ink_red[i]],{'I_e':376.0})

if condition[1]==2:
    for i in range(0,neuron_start_ink-1):
        nest.SetStatus([ink_blue[i]],{'I_e':376.0})

if condition[2]==1:
    for i in range(0,neuron_start_word-1):
        nest.SetStatus([word_red[i]],{'I_e':376.0})

if condition[2]==2:
    for i in range(0,neuron_start_word-1):
        nest.SetStatus([word_blue[i]],{'I_e':376.0})

nest.Simulate(simu_time)

pylab.figure(1,figsize=(20,20))

pylab.subplot(4,2,1)
pylab.title('Inhibition_Ink')
stroop_fun.plot_spikes(spike_inhi_ink,'g.',ca_number_ink*firing_rate,simu_time)
pylab.subplot(4,2,2)
pylab.title('Inhibition_Word')
stroop_fun.plot_spikes(spike_inhi_word,'c.',ca_number_ink*firing_rate,simu_time)
pylab.subplot(4,2,3)
pylab.title('Ink_Red')
stroop_fun.plot_spikes(spike_ink_red,'r.',ca_number_ink*firing_rate,simu_time)
pylab.subplot(4,2,4)
pylab.title('Ink_Blue')
stroop_fun.plot_spikes(spike_ink_blue,'b.',ca_number_ink*firing_rate,simu_time)
pylab.subplot(4,2,5)
pylab.title('Word_Red')
stroop_fun.plot_spikes(spike_word_red,'r.',ca_number_word*firing_rate,simu_time)
pylab.subplot(4,2,6)
pylab.title('Word_Blue')
stroop_fun.plot_spikes(spike_word_blue,'b.',ca_number_word*firing_rate,simu_time)
pylab.subplot(4,2,7)
pylab.title('Output_red')
stroop_fun.plot_spikes(spike_out_red,'r.',ca_number_ink*firing_rate,simu_time)
pylab.subplot(4,2,8)
pylab.title('Output_Blue')
stroop_fun.plot_spikes(spike_out_blue,'b.',ca_number_ink*firing_rate,simu_time)
pylab.show()